Main Page Modules Data Structures File List Data Fields Globals Related Pages

# beecrypt/dhaes.h File Reference

DHAES, header. More...

`#include "beecrypt.h"`
`#include "dldp.h"`

Go to the source code of this file.

## Data Structures
struct | dhaes_pContext
struct | dhaes_pParameters
## Functions
int | dhaes_pUsable (const dhaes_pParameters *params)
int | dhaes_pContextInit (dhaes_pContext *ctxt, const dhaes_pParameters *params)
int | dhaes_pContextInitDecrypt (dhaes_pContext *ctxt, const dhaes_pParameters *params, const mp32number *pri)
int | dhaes_pContextInitEncrypt (dhaes_pContext *ctxt, const dhaes_pParameters *params, const mp32number *pub)
int | dhaes_pContextFree (dhaes_pContext *ctxt)
memchunk * | dhaes_pContextEncrypt (dhaes_pContext *ctxt, mp32number *ephemeralPublicKey, mp32number *mac, const memchunk *cleartext, randomGeneratorContext *rng)
| NOTE: blockciphers and keyed hash functions take keys with sizes specified in bits and key data passed in 32-bit words. More...
memchunk * | dhaes_pContextDecrypt (dhaes_pContext *ctxt, const mp32number *ephemeralPublicKey, const mp32number *mac, const memchunk *ciphertext)

## Detailed Description

DHAES, header.

Definition in file dhaes.h.

## Function Documentation

memchunk* dhaes_pContextDecrypt | ( | dhaes_pContext * | ctxt,
|  | const mp32number * | ephemeralPublicKey,
|  | const mp32number * | mac,
|  | const memchunk * | ciphertext
| ) |

| Definition at line 306 of file dhaes.c.

memchunk* dhaes_pContextEncrypt | ( | dhaes_pContext * | ctxt,
|  | mp32number * | ephemeralPublicKey,
|  | mp32number * | mac,
|  | const memchunk * | cleartext,
|  | randomGeneratorContext * | rng
| ) |

| NOTE: blockciphers and keyed hash functions take keys with sizes specified in bits and key data passed in 32-bit words. Both blockcipher and keyed hash function have a min and max key size. This function will split the digest of the shared secret in two halves, and pad with zero bits or truncate if necessary to meet algorithm key size requirements. Definition at line 252 of file dhaes.c.

int dhaes_pContextFree | ( | dhaes_pContext * | ctxt | ) |

| Definition at line 165 of file dhaes.c.

int dhaes_pContextInit | ( | dhaes_pContext * | ctxt,
|  | const dhaes_pParameters * | params
| ) |

| Definition at line 99 of file dhaes.c. Referenced by dhaes_pContextInitDecrypt, and dhaes_pContextInitEncrypt.

int dhaes_pContextInitDecrypt | ( | dhaes_pContext * | ctxt,
|  | const dhaes_pParameters * | params,
|  | const mp32number * | pri
| ) |

| Definition at line 145 of file dhaes.c.

int dhaes_pContextInitEncrypt | ( | dhaes_pContext * | ctxt,
|  | const dhaes_pParameters * | params,
|  | const mp32number * | pub
| ) |

| Definition at line 155 of file dhaes.c.

int dhaes_pUsable | ( | const dhaes_pParameters * | params | ) |

| Definition at line 58 of file dhaes.c. Referenced by dhaes_pContextInit.